/*
ga_search.cc

This C++ file defines member functions for the class GA_SEARCH_MODULE
It was generated with rcsdesign
with template version 1.1

MODIFICATIONS:
Tue Dec 26 21:08:04 EST 2000	Modified with RCS-Design tool.
Tue Dec 26 20:43:06 EST 2000	Modified with RCS-Design tool.
Tue Dec 26 19:25:27 EST 2000	Modified with RCS-Design tool.
Tue Dec 26 17:34:23 EST 2000	Created with RCS-Design tool.

*/

// Include Files
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "ga_search.hh" 	// GA_SEARCH_MODULE definitions
#include "random.hh" 	// Random number generator function definitions
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.


#include "ga_searchn.hh" 	// NML Commands and Status definitions for ga_search
// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Constructor
GA_SEARCH_MODULE::GA_SEARCH_MODULE(int _is_base_class)
{

	// Initialize the NML channels if this module is not being used as the base class for another module.
	if(!_is_base_class)
	{
		INITIALIZE_NML();
	}
	// Add additional code to initialize the module here.
	pop_size = POPULATION_SIZE;
	chrom_lenght = CHROMOSOME_LEGHT;
	num_traits = NUM_TRAITS;

	population = new POPULATION(pop_size, chrom_lenght, num_traits);

	if(population->pop_err != GA_NO_ERROR)
	{
		logError("Error in creating GA_SEARCH_MODULE object!!!");
		status = RCS_ERROR; // let my supervisor know I have a problem.
	}

}

// Overloaded Virtual Functions

/*
INITIALIZE_NML

The INITIALIZE_NML function is ussually called only once from within the
constructor. It should not be called if a derived class will also call it.

*/
void GA_SEARCH_MODULE::INITIALIZE_NML()
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	setErrorLogChannel(new NML(nmlErrorFormat, "errlog", "ga_search", "ga_module.nml"));
	setCmdChannel(new RCS_CMD_CHANNEL(ga_searchFormat, "ga_search_cmd", "ga_search", "ga_module.nml"));
	ga_search_status = new GA_SEARCH_STATUS();
	setStatChannel(new RCS_STAT_CHANNEL(ga_searchFormat, "ga_search_sts", "ga_search", "ga_module.nml"), ga_search_status);
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


}

/*
PRE_PROCESS

The PRE_PROCESS function is called every cycle after the command and
subordinates status have been read but before DECISION_PROCESS is called.
It is intended to be used for tasks such as sensory processing that should
be performed every cycle regardless of the current command or state.

*/
void GA_SEARCH_MODULE::PRE_PROCESS()
{
	// Pre-Processing Code
}

/*
DECISION_PROCESS

The DECISION_PROCESS function is called every cycle as long as there is a non-zero command.
It is expected to call a command function based on commandInData->type.

*/
void GA_SEARCH_MODULE::DECISION_PROCESS()
{
	switch(commandInData->type)
	{
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	case GA_SEARCH_INIT_TYPE:
		INIT((GA_SEARCH_INIT *)commandInData);
		break;

	case GA_SEARCH_HALT_TYPE:
		HALT((GA_SEARCH_HALT *)commandInData);
		break;

	case GA_SEARCH_EVOLVE_TYPE:
		EVOLVE((GA_SEARCH_EVOLVE *)commandInData);
		break;

	case GA_SEARCH_GET_NEXT_GENERATION_TYPE:
		GET_NEXT_GENERATION((GA_SEARCH_GET_NEXT_GENERATION *)commandInData);
		break;

	case GA_SEARCH_SET_CROSSOVER_PROBABILITY_TYPE:
		SET_CROSSOVER_PROBABILITY((GA_SEARCH_SET_CROSSOVER_PROBABILITY *)commandInData);
		break;

	case GA_SEARCH_SET_DECIMAL_TYPE:
		SET_DECIMAL((GA_SEARCH_SET_DECIMAL *)commandInData);
		break;

	case GA_SEARCH_SET_GENE_RANGE_TYPE:
		SET_GENE_RANGE((GA_SEARCH_SET_GENE_RANGE *)commandInData);
		break;

	case GA_SEARCH_SET_MUTATION_PROBABILITY_TYPE:
		SET_MUTATION_PROBABILITY((GA_SEARCH_SET_MUTATION_PROBABILITY *)commandInData);
		break;

	case GA_SEARCH_SET_TRAIT_OFFSET_TYPE:
		SET_TRAIT_OFFSET((GA_SEARCH_SET_TRAIT_OFFSET *)commandInData);
		break;

	case GA_SEARCH_SET_TRAIT_RANGE_TYPE:
		SET_TRAIT_RANGE((GA_SEARCH_SET_TRAIT_RANGE *)commandInData);
		break;

	case GA_SEARCH_SET_TRAIT_START_TYPE:
		SET_TRAIT_START((GA_SEARCH_SET_TRAIT_START *)commandInData);
		break;

	case GA_SEARCH_SET_TYPE_CROSSOVER_TYPE:
		SET_TYPE_CROSSOVER((GA_SEARCH_SET_TYPE_CROSSOVER *)commandInData);
		break;

	case GA_SEARCH_SET_TYPE_DECODING_TYPE:
		SET_TYPE_DECODING((GA_SEARCH_SET_TYPE_DECODING *)commandInData);
		break;

	case GA_SEARCH_SET_TYPE_ELITISM_TYPE:
		SET_TYPE_ELITISM((GA_SEARCH_SET_TYPE_ELITISM *)commandInData);
		break;
		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	default:
		logError("The command %d is not recognized.",commandInData->type);
		break;
	}
}

/*
POST_PROCESS

The POST_PROCESS function is called every cycle after DECISION_PROCESS is called
but before the status and the subordinates commands  have been written.
It is intended to be used for tasks such as output filters that should
be performed every cycle regardless of the current command or state.

*/
void GA_SEARCH_MODULE::POST_PROCESS()
{
	// Post-Processing Code

	// Report the current best individual
	memcpy(ga_search_status->chrom_of_best_indv, 
		population->members[population->bestmember]->gene, 
		chrom_lenght*sizeof(int));
	memcpy(ga_search_status->traits_of_best_indv, 
		population->members[population->bestmember]->trait_val, 
		num_traits*sizeof(double));
	ga_search_status->fitness_of_best_indv = 
	population->members[population->bestmember]->fitness;

	// Report the current worst individual
	memcpy(ga_search_status->chrom_of_worst_indv, 
		population->members[population->worstmember]->gene, 
		chrom_lenght*sizeof(int));
	memcpy(ga_search_status->traits_of_best_indv, 
		population->members[population->bestmember]->trait_val, 
		num_traits*sizeof(double));
	ga_search_status->fitness_of_worst_indv = 
	population->members[population->worstmember]->fitness;
}

// Command Functions

/*
INIT

Parameter(s):
GA_SEARCH_INIT *cmd_in -- NML Message sent from superior.

Most Modules will have an INIT command.
The INIT function is expected to initialize any variables that may be
in an uninitialized or unknown state, send INIT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.

*/
void GA_SEARCH_MODULE::INIT(GA_SEARCH_INIT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		// Send an INIT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


		stateNext(S1);
		// Reinitialize variables here.

	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
	  // Initialize Random Number Generator
	  Randomize();

	  status = RCS_DONE;
	  stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
HALT

Parameter(s):
GA_SEARCH_HALT *cmd_in -- NML Message sent from superior.

Most Modules will have an HALT command.
The HALT function is expected to stop any motion or command execution,
send HALT commands to its subordinates,
wait for the subordinates to be DONE and then inform its superior that it is done.
The state tables should use the STATE_MATCH macro so the diagnostics tool can 
highlight the current line in the state table.

*/
void GA_SEARCH_MODULE::HALT(GA_SEARCH_HALT *cmd_in)
{
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


	if(STATE_MATCH(NEW_COMMAND))
	{
		//Send a HALT command to all subordinates.
		// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

		// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

		stateNext(S1);
	}
	// Wait for all subordinates to report done.
	// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

	else if(STATE_MATCH(S1,
		1))
	// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

	{
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_TRAIT_START
EVOLVE
GET_NEXT_GENERATION

Parameter(s):
GA_SEARCH_SET_TRAIT_START *cmd_in -- NML Message sent from superior.
GA_SEARCH_EVOLVE *cmd_in -- NML Message sent from superior.
GA_SEARCH_GET_NEXT_GENERATION *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_TRAIT_START(GA_SEARCH_SET_TRAIT_START *cmd_in)
{
	// Put state table for GA_SEARCH_SET_TRAIT_START here.
  if(STATE_MATCH(NEW_COMMAND))
    {
      status = RCS_EXEC;
      stateNext(S1);
    }
  else if(STATE_MATCH(S1))
    {
      // Form the next generation
      population->set_trait_start(cmd_in->trait_starts);
      
      status = RCS_DONE;
      stateNext(S2);
    }
  else if(STATE_MATCH(S2))
    {
      // Idle State
    }
}

void GA_SEARCH_MODULE::EVOLVE(GA_SEARCH_EVOLVE *cmd_in)
{
	static int num_of_current_generation;

	// Put state table for GA_SEARCH_EVOLVE here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		num_of_current_generation = 0;
		 
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->next_generation();
		num_of_current_generation++;

		if(num_of_current_generation == cmd_in->num_of_generations)
		{
			status = RCS_DONE;
			stateNext(S2);
		}
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

void GA_SEARCH_MODULE::GET_NEXT_GENERATION(GA_SEARCH_GET_NEXT_GENERATION *cmd_in)
{
	// Put state table for GA_SEARCH_GET_NEXT_GENERATION here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->next_generation();

		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_CROSSOVER_PROBABILITY

Parameter(s):
GA_SEARCH_SET_CROSSOVER_PROBABILITY *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_CROSSOVER_PROBABILITY(GA_SEARCH_SET_CROSSOVER_PROBABILITY *cmd_in)
{
	// Put state table for GA_SEARCH_SET_CROSSOVER_PROBABILITY here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_cross_prob(cmd_in->crossover_probability);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_DECIMAL

Parameter(s):
GA_SEARCH_SET_DECIMAL *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_DECIMAL(GA_SEARCH_SET_DECIMAL *cmd_in)
{
	// Put state table for GA_SEARCH_SET_DECIMAL here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_decimal(cmd_in->decimal_to_set);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_GENE_RANGE

Parameter(s):
GA_SEARCH_SET_GENE_RANGE *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_GENE_RANGE(GA_SEARCH_SET_GENE_RANGE *cmd_in)
{
	// Put state table for GA_SEARCH_SET_GENE_RANGE here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_gene_low(cmd_in->gene_lower_bounds);
		population->set_gene_high(cmd_in->gene_upper_bounds);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_MUTATION_PROBABILITY

Parameter(s):
GA_SEARCH_SET_MUTATION_PROBABILITY *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_MUTATION_PROBABILITY(GA_SEARCH_SET_MUTATION_PROBABILITY *cmd_in)
{
	// Put state table for GA_SEARCH_SET_MUTATION_PROBABILITY here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_mutat_prob(cmd_in->mutation_probability);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_TRAIT_OFFSET

Parameter(s):
GA_SEARCH_SET_TRAIT_OFFSET *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_TRAIT_OFFSET(GA_SEARCH_SET_TRAIT_OFFSET *cmd_in)
{
	// Put state table for GA_SEARCH_SET_TRAIT_OFFSET here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_trait_offset(cmd_in->offset_to_set);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_TRAIT_RANGE

Parameter(s):
GA_SEARCH_SET_TRAIT_RANGE *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_TRAIT_RANGE(GA_SEARCH_SET_TRAIT_RANGE *cmd_in)
{
	// Put state table for GA_SEARCH_SET_TRAIT_RANGE here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_trait_low(cmd_in->trait_lower_bounds);
		population->set_trait_high(cmd_in->trait_upper_bounds);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_TYPE_CROSSOVER

Parameter(s):
GA_SEARCH_SET_TYPE_CROSSOVER *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_TYPE_CROSSOVER(GA_SEARCH_SET_TYPE_CROSSOVER *cmd_in)
{
	// Put state table for GA_SEARCH_SET_TYPE_CROSSOVER here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_cross_type(cmd_in->crossover_type);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_TYPE_DECODING

Parameter(s):
GA_SEARCH_SET_TYPE_DECODING *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_TYPE_DECODING(GA_SEARCH_SET_TYPE_DECODING *cmd_in)
{
	// Put state table for GA_SEARCH_SET_TYPE_DECODING here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_decode_type(cmd_in->decoding_type);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}

/*
SET_TYPE_ELITISM

Parameter(s):
GA_SEARCH_SET_TYPE_ELITISM *cmd_in -- NML Message sent from superior.

*/
void GA_SEARCH_MODULE::SET_TYPE_ELITISM(GA_SEARCH_SET_TYPE_ELITISM *cmd_in)
{
	// Put state table for GA_SEARCH_SET_TYPE_ELITISM here.
	if(STATE_MATCH(NEW_COMMAND))
	{
		status = RCS_EXEC;
		stateNext(S1);
	}
	else if(STATE_MATCH(S1))
	{
		// Form the next generation
		population->set_elit_type(cmd_in->elitism_type);
		 
		status = RCS_DONE;
		stateNext(S2);
	}
	else if(STATE_MATCH(S2))
	{
		// Idle State
	}
}
