/*
ga_searchn.hh

This C++ header file defines the NML Messages used for command and status by GA_SEARCH_MODULE
Template Version 1.1

MODIFICATIONS:
Tue Dec 26 21:08:03 EST 2000	Modified by rcsdesign.
Tue Dec 26 20:43:05 EST 2000	Modified by rcsdesign.
Tue Dec 26 19:25:26 EST 2000	Deleted GA_SEARCH_SET_TRAIT_LOW, 
Tue Dec 26 19:25:26 EST 2000	Modified by rcsdesign.
Tue Dec 26 17:34:23 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef GA_SEARCHN_HH
#define GA_SEARCHN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


#define CHROMOSOME_LEGHT 14
#define NUM_TRAITS 2       
#define POPULATION_SIZE 20       

// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define GA_SEARCH_STATUS_TYPE 1000
#define GA_SEARCH_EVOLVE_TYPE 1001
#define GA_SEARCH_GET_NEXT_GENERATION_TYPE 1002
#define GA_SEARCH_HALT_TYPE 1003
#define GA_SEARCH_INIT_TYPE 1004
#define GA_SEARCH_SET_CROSSOVER_PROBABILITY_TYPE 1005
#define GA_SEARCH_SET_DECIMAL_TYPE 1006
#define GA_SEARCH_SET_GENE_RANGE_TYPE 1007
#define GA_SEARCH_SET_MUTATION_PROBABILITY_TYPE 1008
#define GA_SEARCH_SET_TRAIT_OFFSET_TYPE 1009
#define GA_SEARCH_SET_TRAIT_RANGE_TYPE 1010
#define GA_SEARCH_SET_TRAIT_START_TYPE 1011
#define GA_SEARCH_SET_TYPE_CROSSOVER_TYPE 1012
#define GA_SEARCH_SET_TYPE_DECODING_TYPE 1013
#define GA_SEARCH_SET_TYPE_ELITISM_TYPE 1014
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class GA_SEARCH_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	GA_SEARCH_STATUS();

	// Constructor used by derived classes
	GA_SEARCH_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

        // The best individual information  
	double chrom_of_best_indv[CHROMOSOME_LEGHT];
	double traits_of_best_indv[NUM_TRAITS];
	double fitness_of_best_indv;

        // The worst individual information 
	double chrom_of_worst_indv[CHROMOSOME_LEGHT];
	double traits_of_worst_indv[NUM_TRAITS];
	double fitness_of_worst_indv;

};

// Command Classes

class GA_SEARCH_SET_TRAIT_START : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_TRAIT_START();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  int trait_starts[NUM_TRAITS];

};

class GA_SEARCH_EVOLVE : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_EVOLVE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	int num_of_generations;

	// Or you can add here another stopping criteria
	// double stopping_criteria;

};

class GA_SEARCH_GET_NEXT_GENERATION : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_GET_NEXT_GENERATION();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class GA_SEARCH_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class GA_SEARCH_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class GA_SEARCH_SET_CROSSOVER_PROBABILITY : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_CROSSOVER_PROBABILITY();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	double crossover_probability;
};

class GA_SEARCH_SET_DECIMAL : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_DECIMAL();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	int decimal_to_set[NUM_TRAITS];
};

class GA_SEARCH_SET_GENE_RANGE : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_GENE_RANGE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	int gene_lower_bounds[CHROMOSOME_LEGHT];
	int gene_upper_bounds[CHROMOSOME_LEGHT];
};

class GA_SEARCH_SET_MUTATION_PROBABILITY : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_MUTATION_PROBABILITY();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	double mutation_probability;
};

class GA_SEARCH_SET_TRAIT_OFFSET : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_TRAIT_OFFSET();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	double offset_to_set[NUM_TRAITS];

};

class GA_SEARCH_SET_TRAIT_RANGE : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_TRAIT_RANGE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	double trait_lower_bounds[NUM_TRAITS];
	double trait_upper_bounds[NUM_TRAITS];  
};

class GA_SEARCH_SET_TYPE_CROSSOVER : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_TYPE_CROSSOVER();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	int crossover_type;
};

class GA_SEARCH_SET_TYPE_DECODING : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_TYPE_DECODING();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	int decoding_type;
};

class GA_SEARCH_SET_TYPE_ELITISM : public RCS_CMD_MSG
{
public:

	//Constructor
	GA_SEARCH_SET_TYPE_ELITISM();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
	int elitism_type;
};

// Declare NML format function
extern int ga_searchFormat(NMLTYPE, void *, CMS *);

#endif 	// GA_SEARCHN_HH
